#pragma once

#include <acs-driver/mfrc522.hpp>
#include <acs-driver/ssd1306.hpp>
#include <acs-driver/gpio.hpp>

namespace acs
{
    class devices
    {
        mfrc522 rfid_;
        ssd1306 oled_;
        gpio extra_;

    public:
        explicit devices() : rfid_(2, 0, 27), oled_(1, 0, 22, 61), extra_(44)
        {
            extra_.set_direction(gpio::output);
            extra_.stream_open();
            extra_.stream_write(gpio::low);
        }

        mfrc522* rfid()
        {
            return &rfid_;
        }

        ssd1306* oled()
        {
            return &oled_;
        }

        gpio* extra()
        {
            return &extra_;
        }
    };
}