#include "mysql_conn.hpp"
#include <iostream>

namespace acs
{
    mysql_conn::mysql_conn() : conn_(false)
    {
        if (!conn_.connect("acs", "localhost", "acs", "testpass", 3306))
        {
            std::cerr << "Failed to connect to database." << std::endl;
            exit(1);
        }
    }

    std::string mysql_conn::get_stunum(uint32_t uid)
    {
        char query_str[60] = { 0 };
        std::sprintf(query_str, "SELECT `stunum` FROM `auth` WHERE uid = %d LIMIT 1", uid);
        auto query = conn_.query(query_str);
        auto result = query.store();
        if (!result)
            return {};
        for (auto&& row : result)
            return row[0].c_str();
        return {};
    }

    bool mysql_conn::stunum_exists(const std::string& stunum)
    {
         std::string query_str("SELECT `id` FROM `auth` WHERE stunum = \"");
         auto query = conn_.query(query_str + stunum + "\" LIMIT 1");
         return query.store();
    }
}
