#pragma once

#include <boost/asio.hpp>

namespace acs
{
    class loop;
    class mysql_conn;
    class request_delegate;
    class access_controller;
    class request_timer
    {
        loop* loop_;

        boost::asio::deadline_timer timer_;

        mysql_conn* conn_;

        request_delegate* request_delegate_;

        access_controller* controller_;

        void response_handler(const std::pair<std::string, std::string>& response);

        void callback_handler(const boost::system::error_code& ec);
        void defer();
    public:
        explicit request_timer();
    };
}
